Package org.springframework.beans.factory

# Interface BeanFactory

All Known Subinterfaces:
  `AutowireCapableBeanFactory`, `ConfigurableBeanFactory`, `ConfigurableListableBeanFactory`, `HierarchicalBeanFactory`, `ListableBeanFactory`

All Known Implementing Classes:
  `AbstractAutowireCapableBeanFactory`, `AbstractBeanFactory`, `DefaultListableBeanFactory`, `StaticListableBeanFactory`

public interface BeanFactory
The root interface for accessing a Spring bean container.

This is the basic client view of a bean container; further interfaces such as `ListableBeanFactory` and `ConfigurableBeanFactory` are available for specific purposes.

This interface is implemented by objects that hold a number of bean definitions, each uniquely identified by a String name. Depending on the bean definition, the factory will return either an independent instance of a contained object (the Prototype design pattern), or a single shared instance (a superior alternative to the Singleton design pattern, in which the instance is a singleton in the scope of the factory). Which type of instance will be returned depends on the bean factory configuration: the API is the same. Since Spring 2.0, further scopes are available depending on the concrete application context (for example, "request" and "session" scopes in a web environment).

The point of this approach is that the BeanFactory is a central registry of application components, and centralizes configuration of application components (no more do individual objects need to read properties files, for example). See chapters 4 and 11 of "Expert One-on-One J2EE Design and Development" for a discussion of the benefits of this approach.

Note that it is generally better to rely on Dependency Injection ("push" configuration) to configure application objects through setters or constructors, rather than use any form of "pull" configuration like a BeanFactory lookup. Spring's Dependency Injection functionality is implemented using this BeanFactory interface and its subinterfaces.

Normally a BeanFactory will load bean definitions stored in a configuration source (such as an XML document), and use the `org.springframework.beans` package to configure the beans. However, an implementation could simply return Java objects it creates as necessary directly in Java code. There are no constraints on how the definitions could be stored: LDAP, RDBMS, XML, properties file, etc. Implementations are encouraged to support references amongst beans (Dependency Injection).

In contrast to the methods in `ListableBeanFactory`, all of the operations in this interface will also check parent factories if this is a `HierarchicalBeanFactory`. If a bean is not found in this factory instance, the immediate parent factory will be asked. Beans in this factory instance are supposed to override beans of the same name in any parent factory.

Bean factory implementations should support the standard bean lifecycle interfaces as far as possible. The full set of initialization methods and their standard order is:

1. BeanNameAware's `setBeanName`
2. BeanClassLoaderAware's `setBeanClassLoader`
3. BeanFactoryAware's `setBeanFactory`
4. EnvironmentAware's `setEnvironment`
5. EmbeddedValueResolverAware's `setEmbeddedValueResolver`
6. ResourceLoaderAware's `setResourceLoader` (only applicable when running in an application context)
7. ApplicationEventPublisherAware's `setApplicationEventPublisher` (only applicable when running in an application context)
8. MessageSourceAware's `setMessageSource` (only applicable when running in an application context)
9. ApplicationContextAware's `setApplicationContext` (only applicable when running in an application context)
10. ServletContextAware's `setServletContext` (only applicable when running in a web application context)
11. `postProcessBeforeInitialization` methods of BeanPostProcessors
12. InitializingBean's `afterPropertiesSet`
13. a custom `init-method` definition
14. `postProcessAfterInitialization` methods of BeanPostProcessors

On shutdown of a bean factory, the following lifecycle methods apply:

1. `postProcessBeforeDestruction` methods of DestructionAwareBeanPostProcessors
2. DisposableBean's `destroy`
3. a custom `destroy-method` definition

Since:
  13 April 2001
Author:
  Rod Johnson, Juergen Hoeller, Chris Beams
See Also:
  - `BeanNameAware.setBeanName(java.lang.String)`
  - `BeanClassLoaderAware.setBeanClassLoader(java.lang.ClassLoader)`
  - `BeanFactoryAware.setBeanFactory(org.springframework.beans.factory.BeanFactory)`
  - `org.springframework.context.EnvironmentAware#setEnvironment`
  - `org.springframework.context.EmbeddedValueResolverAware#setEmbeddedValueResolver`
  - `org.springframework.context.ResourceLoaderAware#setResourceLoader`
  - `org.springframework.context.ApplicationEventPublisherAware#setApplicationEventPublisher`
  - `org.springframework.context.MessageSourceAware#setMessageSource`
  - `org.springframework.context.ApplicationContextAware#setApplicationContext`
  - `org.springframework.web.context.ServletContextAware#setServletContext`
  - `BeanPostProcessor.postProcessBeforeInitialization(java.lang.Object, java.lang.String)`
  - `InitializingBean.afterPropertiesSet()`
  - `AbstractBeanDefinition.getInitMethodName()`
  - `BeanPostProcessor.postProcessAfterInitialization(java.lang.Object, java.lang.String)`
  - `DestructionAwareBeanPostProcessor.postProcessBeforeDestruction(java.lang.Object, java.lang.String)`
  - `DisposableBean.destroy()`
  - `AbstractBeanDefinition.getDestroyMethodName()`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`FACTORY_BEAN_PREFIX`
Used to dereference a `FactoryBean` instance and distinguish it from beans created by the FactoryBean.
`static final char`
`FACTORY_BEAN_PREFIX_CHAR`
Character variant of `FACTORY_BEAN_PREFIX`.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`containsBean(String name)`
Does this bean factory contain a bean definition or externally registered singleton instance with the given name?
`String[]`
`getAliases(String name)`
Return the aliases for the given bean name, if any.
`<T> T`
`getBean(Class<T> requiredType)`
Return the bean instance that uniquely matches the given object type, if any.
`<T> T`
`getBean(Class<T> requiredType, Object... args)`
Return an instance, which may be shared or independent, of the specified bean.
`Object`
`getBean(String name)`
Return an instance, which may be shared or independent, of the specified bean.
`<T> T`
`getBean(String name, Class<T> requiredType)`
Return an instance, which may be shared or independent, of the specified bean.
`Object`
`getBean(String name, Object... args)`
Return an instance, which may be shared or independent, of the specified bean.
`<T> ObjectProvider<T>`
`getBeanProvider(Class<T> requiredType)`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.
`<T> ObjectProvider<T>`
`getBeanProvider(org.springframework.core.ResolvableType requiredType)`
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.
`Class<?>`
`getType(String name)`
Determine the type of the bean with the given name.
`Class<?>`
`getType(String name, boolean allowFactoryBeanInit)`
Determine the type of the bean with the given name.
`boolean`
`isPrototype(String name)`
Is this bean a prototype? That is, will `getBean(java.lang.String)` always return independent instances?
`boolean`
`isSingleton(String name)`
Is this bean a shared singleton? That is, will `getBean(java.lang.String)` always return the same instance?
`boolean`
`isTypeMatch(String name, Class<?> typeToMatch)`
Check whether the bean with the given name matches the specified type.
`boolean`
`isTypeMatch(String name, org.springframework.core.ResolvableType typeToMatch)`
Check whether the bean with the given name matches the specified type.

## Field Details

### FACTORY_BEAN_PREFIX

static final String FACTORY_BEAN_PREFIX
Used to dereference a `FactoryBean` instance and distinguish it from beans created by the FactoryBean. For example, if the bean named `myJndiObject` is a FactoryBean, getting `&myJndiObject` will return the factory, not the instance returned by the factory.

See Also:
  - `FACTORY_BEAN_PREFIX_CHAR`
  - Constant Field Values

### FACTORY_BEAN_PREFIX_CHAR

static final char FACTORY_BEAN_PREFIX_CHAR
Character variant of `FACTORY_BEAN_PREFIX`.

Since:
  6.2.6
See Also:
  - Constant Field Values

## Method Details

### getBean

Object getBean(String name) throws BeansException
Return an instance, which may be shared or independent, of the specified bean.

This method allows a Spring BeanFactory to be used as a replacement for the Singleton or Prototype design pattern. Callers may retain references to returned objects in the case of Singleton beans.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the name of the bean to retrieve
Returns:
  an instance of the bean. Note that the return value will never be `null` but possibly a stub for `null` returned from a factory method, to be checked via `equals(null)`. Consider using `getBeanProvider(Class)` for resolving optional dependencies.
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the specified name
  `BeansException` - if the bean could not be obtained

### getBean

<T> T getBean(String name, Class<T> requiredType) throws BeansException
Return an instance, which may be shared or independent, of the specified bean.

Behaves the same as `getBean(String)`, but provides a measure of type safety by throwing a BeanNotOfRequiredTypeException if the bean is not of the required type. This means that ClassCastException can't be thrown on casting the result correctly, as can happen with `getBean(String)`.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the name of the bean to retrieve
  `requiredType` - type the bean must match; can be an interface or superclass
Returns:
  an instance of the bean. Note that the return value will never be `null`. In case of a stub for `null` from a factory method having been resolved for the requested bean, a `BeanNotOfRequiredTypeException` against the NullBean stub will be raised. Consider using `getBeanProvider(Class)` for resolving optional dependencies.
Throws:
  `NoSuchBeanDefinitionException` - if there is no such bean definition
  `BeanNotOfRequiredTypeException` - if the bean is not of the required type
  `BeansException` - if the bean could not be created

### getBean

Object getBean(String name, Object... args) throws BeansException
Return an instance, which may be shared or independent, of the specified bean.

Allows for specifying explicit constructor arguments / factory method arguments, overriding the specified default arguments (if any) in the bean definition. Note that the provided arguments need to match a specific candidate constructor / factory method in the order of declared parameters.

Parameters:
  `name` - the name of the bean to retrieve
  `args` - arguments to use when creating a bean instance using explicit arguments (only applied when creating a new instance as opposed to retrieving an existing one)
Returns:
  an instance of the bean
Throws:
  `NoSuchBeanDefinitionException` - if there is no such bean definition
  `BeanDefinitionStoreException` - if arguments have been given but the affected bean isn't a prototype
  `BeansException` - if the bean could not be created
Since:
  2.5

### getBean

<T> T getBean(Class<T> requiredType) throws BeansException
Return the bean instance that uniquely matches the given object type, if any.

This method goes into `ListableBeanFactory` by-type lookup territory but may also be translated into a conventional by-name lookup based on the name of the given type. For more extensive retrieval operations across sets of beans, use `ListableBeanFactory` and/or `BeanFactoryUtils`.

Parameters:
  `requiredType` - type the bean must match; can be an interface or superclass
Returns:
  an instance of the single bean matching the required type
Throws:
  `NoSuchBeanDefinitionException` - if no bean of the given type was found
  `NoUniqueBeanDefinitionException` - if more than one bean of the given type was found
  `BeansException` - if the bean could not be created
Since:
  3.0
See Also:
  - `ListableBeanFactory`

### getBean

<T> T getBean(Class<T> requiredType, Object... args) throws BeansException
Return an instance, which may be shared or independent, of the specified bean.

Allows for specifying explicit constructor arguments / factory method arguments, overriding the specified default arguments (if any) in the bean definition. Note that the provided arguments need to match a specific candidate constructor / factory method in the order of declared parameters.

This method goes into `ListableBeanFactory` by-type lookup territory but may also be translated into a conventional by-name lookup based on the name of the given type. For more extensive retrieval operations across sets of beans, use `ListableBeanFactory` and/or `BeanFactoryUtils`.

Parameters:
  `requiredType` - type the bean must match; can be an interface or superclass
  `args` - arguments to use when creating a bean instance using explicit arguments (only applied when creating a new instance as opposed to retrieving an existing one)
Returns:
  an instance of the bean
Throws:
  `NoSuchBeanDefinitionException` - if there is no such bean definition
  `BeanDefinitionStoreException` - if arguments have been given but the affected bean isn't a prototype
  `BeansException` - if the bean could not be created
Since:
  4.1

### getBeanProvider

<T> ObjectProvider<T> getBeanProvider(Class<T> requiredType)
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options.

For matching a generic type, consider `getBeanProvider(ResolvableType)`.

Parameters:
  `requiredType` - type the bean must match; can be an interface or superclass
Returns:
  a corresponding provider handle
Since:
  5.1
See Also:
  - `getBeanProvider(ResolvableType)`

### getBeanProvider

<T> ObjectProvider<T> getBeanProvider(org.springframework.core.ResolvableType requiredType)
Return a provider for the specified bean, allowing for lazy on-demand retrieval of instances, including availability and uniqueness options. This variant allows for specifying a generic type to match, similar to reflective injection points with generic type declarations in method/constructor parameters.

Note that collections of beans are not supported here, in contrast to reflective injection points. For programmatically retrieving a list of beans matching a specific type, specify the actual bean type as an argument here and subsequently use `ObjectProvider.orderedStream()` or its lazy streaming/iteration options.

Also, generics matching is strict here, as per the Java assignment rules. For lenient fallback matching with unchecked semantics (similar to the 'unchecked' Java compiler warning), consider calling `getBeanProvider(Class)` with the raw type as a second step if no full generic match is `available` with this variant.

Parameters:
  `requiredType` - type the bean must match; can be a generic type declaration
Returns:
  a corresponding provider handle
Since:
  5.1
See Also:
  - `ObjectProvider.iterator()`
  - `ObjectProvider.stream()`
  - `ObjectProvider.orderedStream()`

### containsBean

boolean containsBean(String name)
Does this bean factory contain a bean definition or externally registered singleton instance with the given name?

If the given name is an alias, it will be translated back to the corresponding canonical bean name.

If this factory is hierarchical, will ask any parent factory if the bean cannot be found in this factory instance.

If a bean definition or singleton instance matching the given name is found, this method will return `true` whether the named bean definition is concrete or abstract, lazy or eager, in scope or not. Therefore, note that a `true` return value from this method does not necessarily indicate that `getBean(java.lang.String)` will be able to obtain an instance for the same name.

Parameters:
  `name` - the name of the bean to query
Returns:
  whether a bean with the given name is present

### isSingleton

boolean isSingleton(String name) throws NoSuchBeanDefinitionException
Is this bean a shared singleton? That is, will `getBean(java.lang.String)` always return the same instance?

Note: This method returning `false` does not clearly indicate independent instances. It indicates non-singleton instances, which may correspond to a scoped bean as well. Use the `isPrototype(java.lang.String)` operation to explicitly check for independent instances.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the name of the bean to query
Returns:
  whether this bean corresponds to a singleton instance
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
See Also:
  - `getBean(java.lang.String)`
  - `isPrototype(java.lang.String)`

### isPrototype

boolean isPrototype(String name) throws NoSuchBeanDefinitionException
Is this bean a prototype? That is, will `getBean(java.lang.String)` always return independent instances?

Note: This method returning `false` does not clearly indicate a singleton object. It indicates non-independent instances, which may correspond to a scoped bean as well. Use the `isSingleton(java.lang.String)` operation to explicitly check for a shared singleton instance.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the name of the bean to query
Returns:
  whether this bean will always deliver independent instances
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
Since:
  2.0.3
See Also:
  - `getBean(java.lang.String)`
  - `isSingleton(java.lang.String)`

### isTypeMatch

boolean isTypeMatch(String name, org.springframework.core.ResolvableType typeToMatch) throws NoSuchBeanDefinitionException
Check whether the bean with the given name matches the specified type. More specifically, check whether a `getBean(java.lang.String)` call for the given name would return an object that is assignable to the specified target type.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the name of the bean to query
  `typeToMatch` - the type to match against (as a `ResolvableType`)
Returns:
  `true` if the bean type matches, `false` if it doesn't match or cannot be determined yet
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
Since:
  4.2
See Also:
  - `getBean(java.lang.String)`
  - `getType(java.lang.String)`

### isTypeMatch

boolean isTypeMatch(String name, Class<?> typeToMatch) throws NoSuchBeanDefinitionException
Check whether the bean with the given name matches the specified type. More specifically, check whether a `getBean(java.lang.String)` call for the given name would return an object that is assignable to the specified target type.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the name of the bean to query
  `typeToMatch` - the type to match against (as a `Class`)
Returns:
  `true` if the bean type matches, `false` if it doesn't match or cannot be determined yet
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
Since:
  2.0.1
See Also:
  - `getBean(java.lang.String)`
  - `getType(java.lang.String)`

### getType

@Nullable Class<?> getType(String name) throws NoSuchBeanDefinitionException
Determine the type of the bean with the given name. More specifically, determine the type of object that `getBean(java.lang.String)` would return for the given name.

For a `FactoryBean`, return the type of object that the FactoryBean creates, as exposed by `FactoryBean.getObjectType()`. This may lead to the initialization of a previously uninitialized `FactoryBean` (see `getType(String, boolean)`).

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the name of the bean to query
Returns:
  the type of the bean, or `null` if not determinable
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
Since:
  1.1.2
See Also:
  - `getBean(java.lang.String)`
  - `isTypeMatch(java.lang.String, org.springframework.core.ResolvableType)`

### getType

@Nullable Class<?> getType(String name, boolean allowFactoryBeanInit) throws NoSuchBeanDefinitionException
Determine the type of the bean with the given name. More specifically, determine the type of object that `getBean(java.lang.String)` would return for the given name.

For a `FactoryBean`, return the type of object that the FactoryBean creates, as exposed by `FactoryBean.getObjectType()`. Depending on the `allowFactoryBeanInit` flag, this may lead to the initialization of a previously uninitialized `FactoryBean` if no early type information is available.

Translates aliases back to the corresponding canonical bean name.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the name of the bean to query
  `allowFactoryBeanInit` - whether a `FactoryBean` may get initialized just for the purpose of determining its object type
Returns:
  the type of the bean, or `null` if not determinable
Throws:
  `NoSuchBeanDefinitionException` - if there is no bean with the given name
Since:
  5.2
See Also:
  - `getBean(java.lang.String)`
  - `isTypeMatch(java.lang.String, org.springframework.core.ResolvableType)`

### getAliases

String[] getAliases(String name)
Return the aliases for the given bean name, if any.

All of those aliases point to the same bean when used in a `getBean(java.lang.String)` call.

If the given name is an alias, the corresponding original bean name and other aliases (if any) will be returned, with the original bean name being the first element in the array.

Will ask the parent factory if the bean cannot be found in this factory instance.

Parameters:
  `name` - the bean name to check for aliases
Returns:
  the aliases, or an empty array if none
See Also:
  - `getBean(java.lang.String)`